#!perl
# jased on GC33R7A_die-3-geozeichen-jagen-dr-zodiac/GC33R7A_die-3-geozeichen-jagen-dr-zodiac2.pl by Hubert Feyrer
#
# Extract "straight" words from boggle solver output
# horizontal, vertical, diagonal, reversed
#
# Usage:
# cat GC33R7A_die-3-geozeichen-jagen-dr-zodiac.pl.out3 | perl GC33R7A_die-3-geozeichen-jagen-dr-zodiac2.pl
#
# Copyright (c) 2019 Hubert Feyrer <hubert@feyrer.de>
# Alle Rechte vorbehalten.

###########################################################################
sub rotN {
    my ( $word, $n )  = @_;
    my $res="";
    my $x;

    foreach $c ( split(//, uc($word))) {
       $x = ord($c) - ord('A');
       $x += $n;
       $x = $x % 26;
       $x += ord('A');
       $x=chr($x);
       print "c=$c, x=$x\n";
       $res .= $x;
    }

    return $res;
}

###########################################################################
###########################################################################
### M A I N
###########################################################################
###########################################################################
while(<>) {
    next if !/([^:]*): (\d+) - (.*)/;
    print "$1 - $3 (score: $2)\n"; 

    $wort=$1;
    $score=$2;
    $kss=$3;
    foreach $ks (split(/ /, $kss)) {
	$good=1;
	$this_x="";  $this_y="";
	$last_x="";  $last_y="";
	$this_dx=""; $this_dy="";
	$last_dx=""; $last_dy="";
	
	foreach $k (split(/-/, $ks)) {
	    ($this_x, $this_y) = ($k =~ /^.(\d+),(\d+).$/);
	    
	    $this_dx = $this_x - $last_x if $last_x ne "";
	    $this_dy = $this_y - $last_y if $last_y ne "";
	    
	    print "good=$good, k=$k, thix_x=$this_x, this_y=$this_y, this_dx=$this_dx, this_dy=$this_dy, last_dx=$last_dx, last_dy=$last_dy\n";
	    
	    if ($last_dx ne "" and
		$last_dy ne "" and
		$this_dx ne "" and
		$this_dy ne "") {
		if ($this_dx != $last_dx or
		    $this_dy != $last_dy) {
		    $good = 0;
		}
	    }
	    
	    
	    $last_x = $this_x;
	    $last_y = $this_y;
	    $last_dx = $this_dx;
	    $last_dy = $this_dy;
	}
	if ($good) {
	    $rot=rotN(uc($wort), 26-$score);
	    print "straight: $wort - $ks - rot: $score => $rot\n";
	}
    }
    
    print "\n";
}
